package com.kakao.sdk.auth

import com.kakao.sdk.auth.model.OAuthToken
import com.kakao.sdk.auth.model.AccessTokenResponse
import io.reactivex.Observable
import java.util.*

/**
 * @author kevin.kang. Created on 2018. 5. 10..
 */
class TestAccessTokenRepo(var token: OAuthToken) : AccessTokenRepo {
    override fun fromCache(): OAuthToken {
        return token
    }

    override fun toCache(accessTokenResponse: AccessTokenResponse): OAuthToken {
        token = OAuthToken(
            accessTokenResponse.accessToken,
            Date(Date().time + 1000L * accessTokenResponse.accessTokenExpiresIn),
            accessTokenResponse.refreshToken,
            Date(Date().time + 1000L * (accessTokenResponse.refreshTokenExpiresIn ?: 0)),
            listOf()
        )
        return token
    }

    override fun clearCache() {
        token = OAuthToken()
    }
}