package com.kakao.sdk.auth

import com.kakao.sdk.auth.model.AccessTokenResponse
import io.reactivex.observers.TestObserver
import okhttp3.mockwebserver.MockResponse
import okhttp3.mockwebserver.MockWebServer
import org.junit.jupiter.api.Assertions
import org.junit.jupiter.api.Test
import retrofit2.Retrofit
import retrofit2.adapter.rxjava2.RxJava2CallAdapterFactory
import retrofit2.converter.gson.GsonConverterFactory

/**
 * @author kevin.kang. Created on 15/04/2019..
 */
class OkHttpBugTest {
    @Test
    fun loopback() {
        val server = MockWebServer()
        server.enqueue(MockResponse().setResponseCode(200))
        val api = Retrofit.Builder().baseUrl(server.url("/"))
            .addCallAdapterFactory(RxJava2CallAdapterFactory.create())
            .addConverterFactory(GsonConverterFactory.create()).build().create(RxAuthApi::class.java)
        api.issueAccessToken(
            authCode = "auth_code",
            clientId = "some_client_id",
            redirectUri = "https://example.com/oauth",
            androidKeyHash = "sample_key_hash"
        ).subscribe(TestObserver<AccessTokenResponse>())
        val request = server.takeRequest()
        Assertions.assertNotNull(request.requestUrl)
        server.shutdown()
    }
}