package com.kakao.sdk.auth.network

import com.kakao.sdk.auth.AccessTokenRepo
import com.kakao.sdk.common.model.ClientError
import com.kakao.sdk.common.model.ClientErrorCause
import com.kakao.sdk.common.Constants
import okhttp3.Interceptor
import okhttp3.Response

/**
 * @author kevin.kang. Created on 2018. 3. 22..
 */
class AccessTokenInterceptor(private val tokenRepo: AccessTokenRepo = AccessTokenRepo.instance) :
    Interceptor {
    override fun intercept(chain: Interceptor.Chain): Response {
        var request = chain.request()
        val token = tokenRepo.fromCache().accessToken
            ?: throw ClientError(
                ClientErrorCause.TokenNotFound,
                "Access token not found."
            )
        request = request.newBuilder()
            .addHeader(Constants.AUTHORIZATION, "${Constants.BEARER} $token")
            .build()
        return chain.proceed(request)
    }
}