package com.kakao.sdk.user.model

import android.os.Parcelable
import com.google.gson.annotations.SerializedName
import com.kakao.sdk.common.json.UnknownValue
import kotlinx.android.parcel.Parcelize

/**
 * @author kevin.kang. Created on 2018. 3. 24..
 */
@Parcelize
data class User(
    val id: Long,
    val properties: Map<String, String>?,
    val kakaoAccount: Account?,
    val groupUserToken: String?
) : Parcelable

/**
 * @author kevin.kang. Created on 2018. 4. 25..
 */
@Parcelize
data class Account(
    val emailNeedsAgreement: Boolean?,
    val isEmailValid: Boolean?,
    val isEmailVerified: Boolean?,
    val email: String?,

    val ageRangeNeedsAgreement: Boolean?,
    val ageRange: AgeRange?,

    val birthyearNeedsAgreement: Boolean?,
    val birthyear: String?,

    val birthdayNeedsAgreement: Boolean?,
    val birthday: String?,

    val genderNeedsAgreement: Boolean?,
    val gender: Gender?,

    val ciNeedsAgreement: Boolean?,
    val ci: String?,

    val legalNameNeedsAgreement: Boolean?,
    val legalName: String?,

    val legalBirthDateNeedsAgreement: Boolean?,
    val legalBirthDate: String?,

    val legalGenderNeedsAgreement: Boolean?,
    val legalGender: Gender?,

    val phoneNumberNeedsAgreement: Boolean?,
    val phoneNumber: String?
) : Parcelable

enum class AgeRange {
    @SerializedName("0~9")
    AGE_0_9,
    @SerializedName("10~14")
    AGE_10_14,
    @SerializedName("15~19")
    AGE_15_19,
    @SerializedName("20~29")
    AGE_20_29,
    @SerializedName("30~39")
    AGE_30_39,
    @SerializedName("40~49")
    AGE_40_49,
    @SerializedName("50~59")
    AGE_50_59,
    @SerializedName("60~69")
    AGE_60_69,
    @SerializedName("70~79")
    AGE_70_79,
    @SerializedName("80~89")
    AGE_80_89,
    @SerializedName("90~")
    AGE_90_ABOVE,
    @UnknownValue
    UNKNOWN;
}

enum class Gender {
    @SerializedName("female")
    FEMALE,
    @SerializedName("male")
    MALE,
    @UnknownValue
    UNKNOWN
}