package com.kakao.sdk.user.model

import com.google.gson.JsonObject
import com.kakao.sdk.common.KakaoJson
import com.kakao.sdk.common.util.Utility
import org.junit.jupiter.api.Assertions.*
import org.junit.jupiter.api.Test

/**
 * @author kevin.kang. Created on 04/04/2019..
 */
class UserShippingAddressesTest {
    @Test
    fun simple() {
        val body = Utility.getJson("json/shipping_addresses/normal.json")
        val expected = KakaoJson.fromJson<JsonObject>(body, JsonObject::class.java)
        val response =
            KakaoJson.fromJson<UserShippingAddresses>(body, UserShippingAddresses::class.java)

        assertEquals(expected["user_id"].asLong, response.userId)
        assertEquals(
            expected["shipping_addresses_needs_agreement"].asBoolean,
            response.needsAgreement
        )

        val expectedAddresses = expected["shipping_addresses"].asJsonArray
        val addresses = response.shippingAddresses
        assertEquals(expectedAddresses.size(), addresses?.size)
        addresses?.forEach {

        }
    }
}