package com.kakao.sdk.talk.model

import com.google.gson.JsonObject
import com.kakao.sdk.common.KakaoJson
import com.kakao.sdk.common.util.Utility
import com.kakao.sdk.talk.Constants
import org.junit.jupiter.api.Assertions.assertEquals
import org.junit.jupiter.params.ParameterizedTest
import org.junit.jupiter.params.provider.ValueSource

/**
 * @author kevin.kang. Created on 2018. 4. 28..
 */
class TalkProfileTest {
    @ValueSource(strings = ["full_profile"])
    @ParameterizedTest
    fun parse(path: String) {
        val body = Utility.getJson("json/profile/$path.json")
        val expected = KakaoJson.fromJson<JsonObject>(body, JsonObject::class.java)
        val response = KakaoJson.fromJson<TalkProfile>(body, TalkProfile::class.java)

        assertEquals(expected[Constants.NICKNAME].asString, response.nickname)
        assertEquals(expected[Constants.PROFILE_IMAGE_URL].asString, response.profileImageUrl)
        assertEquals(expected[Constants.THUMBNAIL_URL].asString, response.thumbnailUrl)
        assertEquals(expected[Constants.COUNTRY_ISO].asString, response.countryISO)
    }
}