package com.kakao.sdk.talk.model

import android.os.Parcelable
import com.google.gson.annotations.SerializedName
import com.kakao.sdk.common.KakaoJson
import kotlinx.android.parcel.Parcelize

/**
 * @author kevin.kang. Created on 2018. 3. 22..
 */
@Parcelize
data class Friends<T : Parcelable>(val totalCount: Int, val elements: List<T>) : Parcelable {
    companion object {
        fun <T : Parcelable> fromJson(string: String, clazz: Class<T>): Friends<T> =
            KakaoJson.parameterizedFromJson(string, Friends::class.java, clazz)
    }
}

@Parcelize
data class Friend(
    val id: Long,
    val uuid: String,
    val profileNickname: String,
    val profileThumbnailImage: String,
    val favorite: Boolean
) : Parcelable

enum class Order {
    @SerializedName("asc")
    ASC,
    @SerializedName("desc")
    DESC
}