package com.kakao.sdk.template

import kotlinx.android.parcel.Parcelize

/**
 * @author kevin.kang. Created on 2019-09-20..
 */
interface DefaultTemplate

class FeedTemplate(
    val content: Content,
    val social: Social? = null,
    val buttons: List<Button> = mutableListOf()
) : DefaultTemplate {
    val objectType = Constants.TYPE_FEED
}

data class ListTemplate(
    val headerTitle: String,
    val headerLink: Link,
    val contents: List<Content>? = mutableListOf(),
    val buttons: List<Button>? = mutableListOf()
) : DefaultTemplate {
    val objectType = Constants.TYPE_LIST
}

data class CommerceTemplate(
    val content: Content,
    val commerce: Commerce,
    val buttons: List<Button>? = mutableListOf()
) : DefaultTemplate {
    val objectType = Constants.TYPE_COMMERCE
}

data class LocationTemplate(
    val address: String,
    val content: Content,
    val addressTitle: String? = null,
    val social: Social? = null,
    val buttons: List<Button> = mutableListOf()
) : DefaultTemplate {
    val objectType = Constants.TYPE_LOCATION
}

data class TextTemplate(
    val text: String,
    val link: Link,
    val buttonTitle: String,
    val buttons: List<Button> = mutableListOf()
) {
    val objectType = Constants.TYPE_TEXT
}