package com.kakao.sdk.story.model

import android.os.Parcelable
import com.google.gson.annotations.SerializedName
import com.kakao.sdk.common.json.UnknownValue
import com.kakao.sdk.story.Constants
import kotlinx.android.parcel.Parcelize

/**
 * @author kevin.kang. Created on 2018. 3. 20..
 */
@Parcelize
data class StoryProfile(
    @SerializedName(Constants.NICKNAME) val nickname: String,
    @SerializedName(Constants.PROFILE_IMAGE_URL) val profileImageUrl: String,
    @SerializedName(Constants.THUMBNAIL_URL) val thumbnailUrl: String,
    @SerializedName(Constants.BG_IMAGE_URL) val bgImageUrl: String,
    val permalink: String,
    val birthday: String,
    @SerializedName(Constants.BIRTHDAY_TYPE) val birthdayType: BirthdayType
) : Parcelable

enum class BirthdayType {
    /**
     * 양력 생일
     */
    SOLAR,
    /**
     * 음력 생일
     */
    LUNAR,
    @UnknownValue
    UNKNOWN;
}