package com.kakao.sdk.user.model

import com.google.gson.JsonObject
import com.kakao.sdk.common.KakaoJson
import com.kakao.sdk.common.util.Utility
import com.kakao.sdk.user.Constants
import org.junit.jupiter.api.Assertions.assertEquals
import org.junit.jupiter.api.Disabled
import org.junit.jupiter.params.ParameterizedTest
import org.junit.jupiter.params.provider.ValueSource

/**
 * @author kevin.kang. Created on 2018. 4. 25..
 */
class AccessTokenInfoTest {

    @ValueSource(strings = ["internal", "external"])
    @ParameterizedTest
    @Disabled
    fun parse(path: String) {
        val body = Utility.getJson("json/token_info/$path.json")
        val expected = KakaoJson.fromJson<JsonObject>(body, JsonObject::class.java)
        val response = KakaoJson.fromJson<AccessTokenInfo>(body, AccessTokenInfo::class.java)

        assertEquals(expected[Constants.APPID].asLong, response.appId)
        assertEquals(expected[Constants.EXPIRESINMILLIS].asLong, response.expiresInMillis)
        assertEquals(expected[Constants.ID].asLong, response.id)
    }
}